structure IL4Examples =
struct
  local
    open IL4
    val f = Variable.newNamed "f"
    val fvar = ValVar f
    val g = Variable.newNamed "g"
    val gvar = ValVar g
    val x = Variable.newNamed "x"
    val xvar = ValVar x
    val y = Variable.newNamed "y"
    val yvar = ValVar y
    val i = Variable.newNamed "i"
    val ivar = ValVar i
    val j = Variable.newNamed "j"
    val jvar = ValVar j
    val k = Variable.newNamed "k"
    val kvar = ValVar k
    val a = Variable.newNamed "a"
    val avar = ConVar a
  in
    val con1 = TyCont(tyInt)
    val con2 = TyCont(TyProd[tyInt, TyCont tyInt])
    val con3 = TyRef(TySum[tyUnit, tyUnit])
    val con4 = TyForall(a, KndType, avar)
    val efun1 =
      ExHalt
        (ValFix(1, [(f, x, TyProd[tyInt, TyCont tyInt],
              ExApp(fvar, xvar))]))
    val efun2 =
      ExLet(BndVal(f,
        (ValFix(2,
          [ (f, x, tyInt, ExHalt xvar),
            (g, x, tyInt, ExApp(fvar, xvar)) ]
        ))), ExApp(fvar, valInt 2))
   val eletfun =
      ExLet(BndVal(i, valInt 1),
      ExLet(BndVal(j, valInt 2),
      ExLet(BndVal(f,
        ValFix(1,
          [(f, x, tyInt, ExLet(BndBinOp(x, ivar, Literal.OpPlus, jvar),
              ExHalt xvar))])),
         ExApp(fvar, valInt 2))))
    val eletfun2 =
      ExLet(BndVal(i, valInt 1),
      ExLet(BndVal(j, valInt 1),
      ExLet(BndVal(f,
        (ValFix(2,
          [ (f, x, TyProd[tyInt, TyCont tyInt],
                ExLet(BndProj(i, 2, xvar),
                  ExApp(ivar, jvar))),
            (g, x, tyInt, ExApp(fvar, ValProd[xvar, gvar])) ]
        ))), ExApp(fvar, valInt 2))))
    val exceptions =
      ExLet(BndNewTag(i, tyUnit),
      ExLet(
        BndVal(j, ValFix(1,
          [(f, x, TyTagged,
            ExIfTagOf(xvar, ivar, (y, ExHalt(valInt 0)), ExHalt(valInt 1)))])),
        ExApp(jvar, ValTagInj(ivar, valUnit))))
    val helloworld = ExLet(BndUnOp(x, Literal.OpPrint,
                                    valString "hello world\n"),
                       ExHalt valUnit)
    val vals =
      ExHalt (ValProd[
        ValSumInj(tyBool, 1, valUnit),
        ValSumInj(TySum[tyInt], 1, valInt 3),
        ValConAbs(a, KndType, ValSumInj(tyBool, 2, valUnit)),
        ValRoll(ConProj1(ConMu(a, KndPair (KndType, KndUnit), ConPair(tyUnit, ConUnit))), valUnit)
        ])
    val con_tests = [con1, con2, con3, con4]
    val exp_tests = [efun1, efun2, eletfun, eletfun2, exceptions,
                     helloworld, vals]
  end
end
