structure ClosureTop :> CONVERT_TOP
             where type kind = IL4.kind
               and type con = IL4.con
               and type term = IL4.exp =
  ConvertTopFn(struct
              structure In =
                struct
                  type kind = IL4.kind
                  type con = IL4.con
                  type term = IL4.exp
                            
                  exception Check = IL4Static.Check
                  exception Error = IL4Static.Error

                  val kind_to_layout = IL4Print.kind_to_layout
                  val con_to_layout = IL4Print.con_to_layout
                  val term_to_layout = IL4Print.exp_to_layout
                end
              
              structure Out =
                struct
                  type kind = IL5.kind
                  type con = IL5.con
                  type term = IL5.exp

                  val kind_to_layout = IL5Print.kind_to_layout
                  val con_to_layout = IL5Print.con_to_layout
                  val term_to_layout = IL5Print.exp_to_layout
                end

               exception Convert = ClosureConvert.Convert
               exception Error = ClosureConvert.Error

               val convert_kind = ClosureConvert.convert_kind
               val convert_con = ClosureConvert.convert_con
               val convert_term = ClosureConvert.convert_exp IL4Static.Ctx.empty
             end)
